Index: trunk/modules/vci_io_bridge/caba/source/src/vci_io_bridge.cpp
===================================================================
--- trunk/modules/vci_io_bridge/caba/source/src/vci_io_bridge.cpp	(revision 405)
+++ trunk/modules/vci_io_bridge/caba/source/src/vci_io_bridge.cpp	(revision 434)
@@ -1367,16 +898,16 @@
         {
             //must not occur!
-            std::cout << "IOMMU ERROR " << name() << "DMA_TLB_IDLE state" << std::endl
+            std::cout << "IOMMU ERROR " << name() << "TLB_IDLE state" << std::endl
                       << "The Page Table entry ins't valid (unmapped)" << std::endl;
                        
-            r_tlb_error_type          = MMU_READ_PT1_UNMAPPED;
-            r_dma_tlb_error_req       = true;
-            r_dma_tlb_req             = false;
-            r_dma_tlb_fsm             = DMA_TLB_IDLE;            
-#if DEBUG_DMA_TLB
-if ( m_debug_dma_tlb_fsm )
+            r_tlb_miss_error       = true;
+            r_dma_tlb_req         = false;
+            r_tlb_fsm             = TLB_IDLE;            
+
+#if DEBUG_TLB_MISS
+if ( m_debug_activated )
 {
-    std::cout << "  <IOB.DMA_PTE1_GET> First level entry Unmapped"
-              << std::hex << " / paddr = " << r_iotlb_paddr.read()
+    std::cout << "  <IOB DMA_PTE1_GET> First level entry Unmapped"
+              << std::hex << " / paddr = " << r_tlb_paddr.read()
               << std::hex << " / PTE = " << entry << std::endl;
 }
@@ -1388,26 +919,25 @@
         {
             // register bypass
-            r_iotlb.set_bypass( r_iotlb_vaddr.read(),
-                                entry & ((1 << (m_paddr_nbits-PAGE_K_NBITS)) - 1), 
+            r_iotlb.set_bypass( r_dma_cmd_vaddr.read(),
+                                entry & ((1 << (vci_param_int::N-PAGE_K_NBITS)) - 1), 
                                 0); //nline, unused 
 
             //&PTE2 = PTBA + IX2 * 8
             // ps: PAGE_K_NBITS corresponds also to the size of a second level page table
-            r_iotlb_paddr = (paddr_t)(entry & ((1<<(m_paddr_nbits-PAGE_K_NBITS))-1)) << PAGE_K_NBITS |
-                                (paddr_t)(((r_iotlb_vaddr.read() & PTD_ID2_MASK) >> PAGE_K_NBITS) << 3);
-            r_tlb_miss_init_req     = true;
-            r_tlb_miss_type         = PTE2_MISS;
-            r_dma_tlb_fsm           = DMA_TLB_WAIT_TRANSACTION;
+            r_tlb_paddr = (vci_addr_t)(entry & ((1<<(vci_param_int::N-PAGE_K_NBITS))-1)) << PAGE_K_NBITS |
+                                (vci_addr_t)(((r_dma_cmd_vaddr.read() & PTD_ID2_MASK) >> PAGE_K_NBITS) << 3);
+            r_tlb_miss_req     = true;
+            r_tlb_miss_type    = PTE2_MISS;
+            r_tlb_fsm          = TLB_WAIT;
+
 #ifdef INSTRUMENTATION
 m_cpt_iotlbmiss_transaction++;
 #endif
 
-#if DEBUG_DMA_TLB
-if ( m_debug_dma_tlb_fsm )
-{
-    std::cout << "  <IOB.DMA_TLB_PTE1_GET> Success. Search PTE2"
-              << std::hex << " / paddr = " << r_iotlb_paddr.read()
-              << std::hex << " / PTD = " << entry << std::endl;
-}
+#if DEBUG_TLB_MISS
+if ( m_debug_activated )
+std::cout << "  <IOB TLB_PTE1_GET> Success. Search PTE2" << std::hex 
+          << " / PADDR = " << r_tlb_paddr.read()
+          << " / PTD = " << entry << std::endl;
 #endif
         }
@@ -1415,26 +945,23 @@
                         //  Should not occur if working only with small pages
         {
-            r_iotlb_pte_flags   = entry;
-            r_dma_tlb_fsm  = DMA_TLB_PTE1_SELECT;
-
-#if DEBUG_DMA_TLB
-if ( m_debug_dma_tlb_fsm )
-{
-    std::cout << "  <IOB.DMA_TLB_PTE1_GET> Success. Big page"
-              << std::hex << " / paddr = " << r_iotlb_paddr.read()
-              << std::hex << " / PTE1 = " << entry << std::endl;
-}
-#endif
-        }
-        
-        break;
-    }
-    ////////////////////////////
-    case DMA_TLB_PTE1_SELECT:	// select a slot for PTE1 
+            r_tlb_pte_flags   = entry;
+            r_tlb_fsm  = TLB_PTE1_SELECT;
+
+#if DEBUG_TLB_MISS
+if ( m_debug_activated )
+std::cout << "  <IOB TLB_PTE1_GET> Success. Big page"
+          << std::hex << " / paddr = " << r_tlb_paddr.read()
+          << std::hex << " / PTE1 = " << entry << std::endl;
+#endif
+        }
+        break;
+    }
+    /////////////////////
+    case TLB_PTE1_SELECT:	// select a slot for PTE1 
     {
         size_t 	way;
         size_t 	set;
         
-        r_iotlb.select(  r_iotlb_vaddr.read(),
+        r_iotlb.select(  r_dma_cmd_vaddr.read(),
                         true,  // PTE1 
                         &way,
@@ -1444,26 +971,23 @@
 #endif
 
-#if DEBUG_DMA_TLB
-if ( m_debug_dma_tlb_fsm )
-{
-    std::cout << "  <IOB.DMA_TLB_PTE1_SELECT> Select a slot in IOTLB:";
-    std::cout << " way = " << std::dec << way
-                  << " / set = " << set << std::endl;
-}
-#endif
-        r_iotlb_way = way;
-        r_iotlb_set = set;
-        r_dma_tlb_fsm     = DMA_TLB_PTE1_UPDT;
-        break;
-    }
-    //////////////////////////
-    case DMA_TLB_PTE1_UPDT:     // write a new PTE1 in tlb
-                                // not necessary to treat the L/R bit
-    {
-        //(OLD) paddr_t	  nline = r_dcache_tlb_paddr.read() >> (uint32_log2(m_dcache_words)+2);   
-        uint32_t  pte   = r_iotlb_pte_flags.read();
+#if DEBUG_TLB_MISS
+if ( m_debug_activated )
+std::cout << "  <IOB TLB_PTE1_SELECT> Select a slot in TLB"
+          << " / way = " << std::dec << way
+          << " / set = " << set << std::endl;
+#endif
+        r_tlb_way = way;
+        r_tlb_set = set;
+        r_tlb_fsm     = TLB_PTE1_UPDT;
+        break;
+    }
+    ///////////////////
+    case TLB_PTE1_UPDT:     // write a new PTE1 in tlb
+                            // not necessary to treat the L/R bit
+    {
+        uint32_t  pte   = r_tlb_pte_flags.read();
         
-        r_miss_paddr = (paddr_t)( ((r_iotlb_pte_flags.read() & PPN1_MASK) << 21)
-                        | (r_iotlb_vaddr.read()& M_PAGE_OFFSET_MASK) );
+        r_tlb_paddr = (vci_addr_t)( ((r_tlb_pte_flags.read() & PPN1_MASK) << 21)
+                        | (r_dma_cmd_vaddr.read()& M_PAGE_OFFSET_MASK) );
         
         // update TLB
@@ -1471,7 +995,7 @@
                       pte,
                       0,		// argument unused for a PTE1
-                      r_iotlb_vaddr.read(),    
-                      r_iotlb_way.read(), 
-                      r_iotlb_set.read(),
+                      r_dma_cmd_vaddr.read(),    
+                      r_tlb_way.read(), 
+                      r_tlb_set.read(),
                       0 );      //we set nline = 0
 #ifdef INSTRUMENTATION
@@ -1479,75 +1003,71 @@
 #endif
 
-#if DEBUG_DMA_TLB
-if ( m_debug_dma_tlb_fsm )
+#if DEBUG_TLB_MISS
+if ( m_debug_activated )
 {
-    std::cout   << "  <IOB.DMA_TLB_PTE1_UPDT> write PTE1 in IOTLB";
-    std::cout   << " / set = " << std::dec << r_iotlb_set.read()
-                << " / way = " << r_iotlb_way.read() << std::endl;
-    r_iotlb.printTrace();
+std::cout << "  <IOB TLB_PTE1_UPDT> write PTE1 in TLB"
+          << " / set = " << std::dec << r_tlb_set.read()
+          << " / way = " << r_tlb_way.read() << std::endl;
+r_iotlb.printTrace();
 }
 #endif
         // next state
-        r_dma_tlb_fsm = DMA_TLB_RETURN;	// exit sub-fsm
-        break;
-    }
-    /////////////////////////
-    case DMA_TLB_PTE2_GET:	// Try to read a PTE2 (64 bits) in the miss buffer
+        r_tlb_fsm = TLB_RETURN;	// exit sub-fsm
+        break;
+    }
+    //////////////////
+    case TLB_PTE2_GET:	// Try to read a PTE2 (64 bits) in the miss buffer
     {    
         uint32_t 	pte_flags;
         uint32_t 	pte_ppn;
         
-        paddr_t line_number  = (paddr_t)((r_iotlb_paddr.read())&(CACHE_LINE_MASK));
-        size_t word_position = (size_t)( ((r_iotlb_paddr.read())&(~CACHE_LINE_MASK))>>2 );
+        vci_addr_t line_number  = (vci_addr_t)((r_tlb_paddr.read())&(CACHE_LINE_MASK));
+        size_t word_position = (size_t)( ((r_tlb_paddr.read())&(~CACHE_LINE_MASK))>>2 );
         
         
         // Hit test. Just to verify.
-        bool hit = (r_miss_buf_valid && (r_miss_buf_tag.read()== line_number) ); 
+        bool hit = (r_tlb_buf_valid && (r_tlb_buf_tag.read()== line_number) ); 
         assert(hit and "Error: No hit on prefetch buffer after Miss Transaction"); 
-        pte_flags= r_miss_buf_data[word_position];
-        pte_ppn= r_miss_buf_data[word_position+1]; //because PTE2 is 2 words long
+        pte_flags= r_tlb_buf_data[word_position];
+        pte_ppn= r_tlb_buf_data[word_position+1]; //because PTE2 is 2 words long
         // Bit valid checking
         if ( not ( pte_flags & PTE_V_MASK) )	// unmapped
         {
             //must not occur!
-            std::cout << "IOMMU ERROR " << name() << "DMA_TLB_IDLE state" << std::endl
+            std::cout << "IOMMU ERROR " << name() << "TLB_IDLE state" << std::endl
                       << "The Page Table entry ins't valid (unmapped)" << std::endl;
                        
-            r_tlb_error_type          = MMU_READ_PT2_UNMAPPED;
-            r_dma_tlb_error_req       = true;
-            r_dma_tlb_req             = false;
-            r_dma_tlb_fsm             = DMA_TLB_IDLE;            
-#if DEBUG_DMA_TLB
-if ( m_debug_dma_tlb_fsm )
-{
-    std::cout << "  <IOB.DMA_TLB_PTE2_GET> PTE2 Unmapped"
-              << std::hex << " / paddr = " << r_iotlb_paddr.read()
-              << std::hex << " / PTE = " << pte_flags << std::endl;
-}
-#endif
-                    break; 
+            r_tlb_miss_error       = true;
+            r_dma_tlb_req         = false;
+            r_tlb_fsm             = TLB_IDLE;            
+
+#if DEBUG_TLB_MISS
+if ( m_debug_activated )
+std::cout << "  <IOB TLB_PTE2_GET> PTE2 Unmapped" << std::hex 
+          << " / PADDR = " << r_tlb_paddr.read()
+          << " / PTE = " << pte_flags << std::endl;
+#endif
+            break; 
         }
             
-        r_iotlb_pte_flags       = pte_flags; 
-        r_iotlb_pte_ppn         = pte_ppn;
-        r_dma_tlb_fsm           = DMA_TLB_PTE2_SELECT;
+        r_tlb_pte_flags       = pte_flags; 
+        r_tlb_pte_ppn         = pte_ppn;
+        r_tlb_fsm           = TLB_PTE2_SELECT;
                 
-#if DEBUG_DMA_TLB
-if ( m_debug_dma_tlb_fsm )
-{
-    std::cout << "  <IOB.DMA_TLB_PTE2_GET> Mapped:"
-              << " PTE_FLAGS = " << std::hex << pte_flags 
-              << " PTE_PPN = " << std::hex << pte_ppn << std::endl;
-}
+#if DEBUG_TLB_MISS
+if ( m_debug_activated )
+std::cout << "  <IOB TLB_PTE2_GET> Mapped" << std::hex
+          << " / PTE_FLAGS = " << pte_flags 
+          << " / PTE_PPN = " << pte_ppn << std::endl;
 #endif
         break;
     }
     ////////////////////////////
-    case DMA_TLB_PTE2_SELECT:    // select a slot for PTE2
+    case TLB_PTE2_SELECT:    // select a slot for PTE2
     {
         size_t way;
         size_t set;
 
-        r_iotlb.select( r_iotlb_vaddr.read(),
+        r_iotlb.select( r_dma_cmd_vaddr.read(),
                         false,	// PTE2 
                         &way,
@@ -1557,27 +1077,26 @@
 #endif
 
-#if DEBUG_DMA_TLB
-if ( m_debug_dma_tlb_fsm )
+#if DEBUG_TLB_MISS
+if ( m_debug_activated )
 {
-        std::cout << "  <IOB.DMA_TLB_PTE2_SELECT> Select a slot in IOTLB:";
+        std::cout << "  <IOB TLB_PTE2_SELECT> Select a slot in IOTLB:";
         std::cout << " way = " << std::dec << way
                   << " / set = " << set << std::endl;
 }
 #endif
-        r_iotlb_way = way;
-        r_iotlb_set = set;
-        r_dma_tlb_fsm     = DMA_TLB_PTE2_UPDT;
-        break;
-    }
-    //////////////////////////
-    case DMA_TLB_PTE2_UPDT:      	// write a new PTE2 in tlb
-                                    // not necessary to treat the L/R bit
-    {
-        //(OLD) paddr_t	        nline     = r_dcache_tlb_paddr.read() >> (uint32_log2(m_dcache_words)+2);   
-        uint32_t        pte_flags = r_iotlb_pte_flags.read();
-        uint32_t        pte_ppn   = r_iotlb_pte_ppn.read();
+        r_tlb_way = way;
+        r_tlb_set = set;
+        r_tlb_fsm     = TLB_PTE2_UPDT;
+        break;
+    }
+    ///////////////////
+    case TLB_PTE2_UPDT:      	// write a new PTE2 in tlb
+                                // not necessary to treat the L/R bit
+    {
+        uint32_t        pte_flags = r_tlb_pte_flags.read();
+        uint32_t        pte_ppn   = r_tlb_pte_ppn.read();
         
-        r_miss_paddr = (paddr_t)( ((r_iotlb_pte_ppn.read() & PPN2_MASK) << 12)
-                        | (r_iotlb_vaddr.read()& K_PAGE_OFFSET_MASK) );
+        r_tlb_paddr = (vci_addr_t)( ((r_tlb_pte_ppn.read() & PPN2_MASK) << 12)
+                        | (r_dma_cmd_vaddr.read()& K_PAGE_OFFSET_MASK) );
         
         // update TLB for a PTE2
@@ -1585,7 +1104,7 @@
                        pte_flags,
                        pte_ppn,
-                       r_iotlb_vaddr.read(),    
-                       r_iotlb_way.read(), 
-                       r_iotlb_set.read(),
+                       r_dma_cmd_vaddr.read(),    
+                       r_tlb_way.read(), 
+                       r_tlb_set.read(),
                        0 );     // nline = 0
 #ifdef INSTRUMENTATION
@@ -1593,26 +1112,26 @@
 #endif
 
-#if DEBUG_DMA_TLB
-if ( m_debug_dma_tlb_fsm )
+#if DEBUG_TLB_MISS
+if ( m_debug_activated )
 {
-        std::cout << "  <IOB.DMA_TLB_PTE2_UPDT> write PTE2 in IOTLB";
-        std::cout << " / set = " << std::dec << r_iotlb_set.read()
-                  << " / way = " << r_iotlb_way.read() << std::endl;
+        std::cout << "  <IOB TLB_PTE2_UPDT> write PTE2 in IOTLB";
+        std::cout << " / set = " << std::dec << r_tlb_set.read()
+                  << " / way = " << r_tlb_way.read() << std::endl;
         r_iotlb.printTrace();
 }
 #endif
         // next state
-        r_dma_tlb_fsm = DMA_TLB_RETURN;	// exit sub-fsm
-        break;
-    }
-    ///////////////////////
-    case DMA_TLB_WAIT_TRANSACTION:
-    {
-        // CONFIG FSM request following a invalidation signal sent by OS.
-        if(r_config_tlb_req)
+        r_tlb_fsm = TLB_RETURN;	
+        break;
+    }
+    //////////////
+    case TLB_WAIT:   // waiting completion of a miss transaction from MISS_WTI FSM
+                     // PTE inval request are handled as unmaskable interrupts
+    {
+        if ( r_config_tlb_req ) // Request from CONFIG FSM for a PTE invalidation 
         {
             r_config_tlb_req = false;
             r_waiting_transaction = true;
-            r_dma_tlb_fsm = DMA_TLB_INVAL_CHECK;
+            r_tlb_fsm = TLB_INVAL_CHECK;
         }
 
@@ -1620,65 +1139,61 @@
 m_cost_iotlbmiss_transaction++;
 #endif
-        if ( not r_tlb_miss_init_req )	//  Miss transaction is done 
+        if ( not r_tlb_miss_req )	//  Miss transaction is done 
         { 
-	        if ( r_miss_init_error.read() ) // bus error 
+	        if ( r_miss_wti_rsp_error.read() ) // bus error 
 	        {
-                r_miss_init_error  = false;
-                r_tlb_error_type    = MMU_READ_DATA_ILLEGAL_ACCESS;
-                r_dma_tlb_error_req     = true;
-                r_dma_tlb_req           = false;
-                r_dma_tlb_fsm = DMA_TLB_IDLE;
+                r_miss_wti_rsp_error = false;
+                r_tlb_miss_error     = true;
+                r_dma_tlb_req        = false;
+                r_tlb_fsm            = TLB_IDLE;
             }
             else if(r_tlb_miss_type == PTE1_MISS)
             {
-                r_dma_tlb_fsm = DMA_TLB_PTE1_GET; 
-        
+                r_tlb_fsm = TLB_PTE1_GET; 
             }
             else
             {
-                r_dma_tlb_fsm = DMA_TLB_PTE2_GET;
+                r_tlb_fsm = TLB_PTE2_GET;
             }
         }
         break;
     }
-    ///////////////////////
-    case DMA_TLB_RETURN:		// return to caller depending on tlb miss type
-    {
-#if DEBUG_DMA_TLB
-if ( m_debug_dma_tlb_fsm )
-{
-    std::cout << "  <IOB.DMA_TLB_RETURN> IOTLB MISS completed" << std::endl;
-}
-#endif
-        r_dma_tlb_req = false;
-        r_tlb_dma_untreated = true;
-        r_dma_tlb_fsm = DMA_TLB_IDLE;
-        break;
-    }
-    //////////////////////
-    case DMA_TLB_INVAL_CHECK:   // request from CONFIG FSM to invalidate all PTE on a given line
-                                // This state checks the necessity to invalidate prefetch buffer
+    ////////////////
+    case TLB_RETURN:		// reset r_dma_tlb_req flip-flop to signal TLB miss completion
+                            // possible errors are signaled through r_tlb_miss_error
+    {
+#if DEBUG_TLB_MISS
+if ( m_debug_activated )
+std::cout << "  <IOB TLB_RETURN> IOTLB MISS completed" << std::endl;
+#endif
+        r_dma_tlb_req  = false;
+        r_tlb_fsm = TLB_IDLE;
+        break;
+    }
+    /////////////////////
+    case TLB_INVAL_CHECK:   // request from CONFIG_FSM to invalidate all PTE in a given line
+                            // checks the necessity to invalidate prefetch buffer
     {
         // If a transaction is pending, no need to invalidate the prefetch
         // We can ignore it, since we'll replace the line.
         // The new line is necessarily up-to-date
-        if(!r_waiting_transaction.read() && r_miss_buf_valid)
-        {
-            if(!r_miss_buf_first_level)
+        if(!r_waiting_transaction.read() && r_tlb_buf_valid)
+        {
+            if(!r_tlb_buf_big_page)
             {
-               if( r_miss_buf_vaddr_begin.read() == 
-                   (r_config_tlb_inval_vaddr.read()& ~PTE2_LINE_OFFSET) ) 
+               if( r_tlb_buf_vaddr.read() == 
+                   (r_config_cmd_inval_vaddr.read()& ~PTE2_LINE_OFFSET) ) 
                 // The virtual address corresponds to one entry on the buffer line
                 {
-                    r_miss_buf_valid = false;   //change here for individual invalidation
+                    r_tlb_buf_valid = false;   //change here for individual invalidation
                 }
             }
             else    // First level entries on buffer. Unused if only small pages
             {
-               if( r_miss_buf_vaddr_begin.read() == 
-                   (r_config_tlb_inval_vaddr.read()& ~PTE1_LINE_OFFSET) ) 
+               if( r_tlb_buf_vaddr.read() == 
+                   (r_config_cmd_inval_vaddr.read()& ~PTE1_LINE_OFFSET) ) 
                 // The virtual address corresponds to one entry on the buffer line
                 {
-                    r_miss_buf_valid = false;   //change here for individual invalidation
+                    r_tlb_buf_valid = false;   //change here for individual invalidation
                 }
             }
